import React, { useRef, useEffect, useState } from "react";
import WebViewer from "@pdftron/pdfjs-express";
import "./App.css";
const App = () => {
  const a = "/files/A.pdf";
  const b = "/files/B.pdf";
  const s = "/files/S.pdf";

  const [state, setState] = useState(s);
  const instance = useRef();
  const viewer = useRef();

  const callA = (pdf) => {
    setState(pdf);
  };
  const callB = (pdf) => {
    setState(pdf);
  };

  const callS = (pdf) => {
    setState(pdf);
  };

  useEffect(() => {
    if (typeof window !== "undefined") {
      WebViewer(
        {
          path: "/webviewer/lib",
          initialDoc: state,
        },
        viewer.current
      ).then((inst) => {
        inst.Core.annotationManager.setCurrentUser("Nikhil");
        console.log(inst.Core.annotationManager.isUserAdmin());

        inst.Core.documentViewer.addEventListener(
          "documentLoaded",
          async () => {
            inst.UI.openElements(["notesPanel"]);
            const data2 = ``;
            const dataB = ``;

            // Below data is with trn-custom data through which we are not able to retain annotation
            // const data = `<?xml version="1.0" encoding="UTF-8" ?><xfdf xmlns="http://ns.adobe.com/xfdf/" xml:space="preserve"><annots><text page="0" rect="451.160,583.351,482.160,614.351" color="#FFCD45" flags="print,nozoom,norotate" name="4c427dbf-7e61-73b7-f202-843baa34e296" title="Nikhil" subject="Comment" date="D:20230504130804+05'30'" creationdate="D:20230504130745+05'30'" icon="Comment" statemodel="Review"><trn-custom-data bytes="{&quot;trn-mention&quot;:&quot;{\&quot;contents\&quot;:\&quot;This comment made to check trn-custom bug\\n\&quot;,\&quot;ids\&quot;:[]}&quot;}"/><contents>This comment made to check trn-custom bug
            // </contents><contents-richtext><body><p><span>This comment made to check trn-custom bug
            // </span></p></body></contents-richtext></text></annots></xfdf>`;

            // below data is  without trn-custom data through which we are able to retain annotation
            const data = `<?xml version="1.0" encoding="UTF-8" ?><xfdf xmlns="http://ns.adobe.com/xfdf/" xml:space="preserve"><annots><text page="0" rect="451.160,583.351,482.160,614.351" color="#FFCD45" flags="print,nozoom,norotate" name="4c427dbf-7e61-73b7-f202-843baa34e296" title="Nikhil" subject="Comment" date="D:20230504130804+05'30'" creationdate="D:20230504130745+05'30'" icon="Comment" statemodel="Review"><contents>This comment made to check trn-custom bug
            </contents><contents-richtext><body><p><span>This comment made to check trn-custom bug
            </span></p></body></contents-richtext></text></annots></xfdf>`;

            // removed line of code:
            {
              /* <trn-custom-data bytes="{&quot;trn-mention&quot;:&quot;{\&quot;contents\&quot;:\&quot;This comment made to check trn-custom bug\\n\&quot;,\&quot;ids\&quot;:[]}&quot;}"/> */
            }

            if (inst.Core.documentViewer.getDocument().filename === "S.pdf") {
              inst.Core.annotationManager.importAnnotations(data);
            } else if (
              inst.Core.documentViewer.getDocument().filename === "A.pdf"
            ) {
              inst.Core.annotationManager.importAnnotations(data2);
            } else {
              inst.Core.annotationManager.importAnnotations(dataB);
            }
          }
        );

        instance.current = inst;
        const saveButto = document.getElementById("save");
        saveButto.addEventListener("click", async () => {
          const vv = inst.Core.annotationManager
            .getAnnotationsList()
            .filter((annot) => annot.Subject === "Comment");
          console.log("Only Comment response", vv);
          //   Getting only comnnet data
          const xfdf = await inst.Core.annotationManager.exportAnnotations({
            annotList: vv,
          });

          console.log(xfdf);
        });
      });
    }
  }, []);
  useEffect(() => {
    if (typeof window !== "undefined") {
      if (instance.current) {
        instance.current.loadDocument(state);
      }
    }
  }, [state]);

  return (
    <div className="App">
      <div style={{ display: "flex", width: "100%", flexDirection: "row" }}>
        <div style={{ width: "20%", display: "flex", flexDirection: "column" }}>
          <button
            style={{
              backgroundColor: "transparent",
              border: "1px solid lightgray",
              padding: "1em",
            }}
            onClick={() => {
              callA(a);
            }}
          >
            A pdf
          </button>
          <button
            style={{
              backgroundColor: "transparent",
              border: "1px solid lightgray",
              padding: "1em",
            }}
            onClick={() => {
              callB(b);
            }}
          >
            B pdf
          </button>
          <button
            style={{
              backgroundColor: "transparent",
              border: "1px solid lightgray",
              padding: "1em",
            }}
            onClick={() => {
              callS(s);
            }}
          >
            S pdf
          </button>
        </div>
        <div style={{ width: "80%" }}>
          <div className="header">React sample</div>{" "}
          <button id="save">Save</button>{" "}
          <div
            className="webviewer"
            style={{ height: "85vh" }}
            ref={viewer}
          ></div>{" "}
        </div>
      </div>
    </div>
  );
};

export default App;
